From a9af4ea75b6fa03a4480db64b6ddafa1ce33a067 Mon Sep 17 00:00:00 2001
From: Kamil Páral <kparal@redhat.com>
Date: May 11 2018 12:16:30 +0000
Subject: [PATCH 2/7] rework lbrabec's patch


It uses dict for data management now. I used the opportunity to
restructure it a bit, all available variables are now documented in
executor.py. The variables are saved into a file to debugging, including
the new ones. There's a new method that takes care of parsing variables
and populating the dictionary, keeping the logic in one place. The
number of debug printouts was reduced where they seemed unnecessary.

A bit unrelated change is removing root=bool support to run the playbook
as a standard user. It was a non-complete feature (not hooked up to
cmdline args), never used, very probably broken. I didn't want to spend
time to hook it up properly to the updated workflow. We can add it back
later if needed.

Please note that testsuite is broken at the moment, will fix it when I
get ack on the patch.

---

diff --git a/libtaskotron/executor.py b/libtaskotron/executor.py
index bbdcb6a..cf07395 100644
--- a/libtaskotron/executor.py
+++ b/libtaskotron/executor.py
@@ -12,6 +12,7 @@ import yaml
 import fnmatch
 import signal
 import json
+import copy
 
 from libtaskotron import config
 from libtaskotron import image_utils
@@ -27,33 +28,68 @@ try:
 except ImportError as e:
     raise exc.TaskotronImportError(e)
 
-
-class Playbook_Data(object):
-    '''Class holding parsed variables from playbook'''
-    def __init__(self, playbook={}):
-        self.match_host_distro = playbook.get('vars', {}).get(
-            'taskotron_match_host_distro', False)
-        log.info("Variable taskotron_match_host_distro is %s", self.match_host_distro)
-
-        self.match_host_release = playbook.get('vars', {}).get(
-            'taskotron_match_host_release', False)
-        log.info("Variable taskotron_match_host_release is %s", self.match_host_release)
-
-        self.match_host_arch = playbook.get('vars', {}).get(
-            'taskotron_match_host_arch', False)
-        log.info("Variable taskotron_match_host_arch is %s", self.match_host_arch)
-
-        if playbook.get('vars',{}).get('taskotron_generic_task', False):
-            self.generic = True
-            self.exec_tasks = 'tasks_generic.yml'
-        else:
-            self.generic = False
-            self.exec_tasks = 'tasks_sti.yml'
-        log.info('Variable taskotron_generic_task is: %s', self.generic)
-
-        self.keepalive = playbook.get('vars', {}).get(
-            'taskotron_keepalive_minutes', None)
-        log.info('Variable taskotron_keepalive_minutes is: %s', self.keepalive)
+#: list of all vars and their defaults used exposed in our runner playbook
+_PLAYBOOK_VARS_TEMPLATE = {
+    # path to the root artifacts directory (on overlord and minion)
+    'artifacts_root': None,
+    # path to the playbook-specific artifacts directory (on overlord and
+    # minion)
+    'artifacts': None,
+    # path to directory with test suite (on minion)
+    'client_taskdir': None,
+    # path to taskotron tasks playbook (generic or STI)
+    'exec_tasks': None,
+    # heartbeat will appear in this file
+    'heartbeat_file': None,
+    # add line to heartbeat_file every x seconds (2 minutes)
+    'heartbeat_interval': 120,
+    # running on local machine (overlord), no remote connection
+    'local': False,
+    # a list of repos (strings) to install on the minion
+    'minion_repos': [],
+    # path to inventory file to be used with STI tests (local inside
+    # client_taskdir or global)
+    'sti_inventory': None,
+    # path to directory with test suite (on overlord)
+    'taskdir': None,
+    # architecture of taskotron_item to be tested
+    'taskotron_arch': None,
+    # whether to run a generic or STI task
+    'taskotron_generic_task': False,
+    # item under test
+    'taskotron_item_type': None,
+    # item type under test
+    'taskotron_item': None,
+    # how long should heartbeat process run (0 to disable)
+    'taskotron_keepalive_minutes': 0,
+    # whether VM guest arch has to match taskotron_arch
+    'taskotron_match_host_arch': False,
+    # whether VM guest distro has to match taskotron_item
+    'taskotron_match_host_distro': False,
+    # whether VM guest release has to match taskotron_item
+    'taskotron_match_host_release': False,
+    # list of base architectures supported by Taskotron (e.g. 'armhfp')
+    'taskotron_supported_arches': None,
+    # list of base+binary architectures supported by Taskotron (e.g. 'armhfp,
+    # armv7hl')
+    'taskotron_supported_binary_arches': None,
+    # path to playbook to execute inside client_taskdir (usually tests.yml)
+    'test_playbook': None,
+    # name of the ansible vars file inside artifacts/taskotron/ to forward to
+    # task
+    'varsfile': 'task_vars.json',
+}
+
+#: list of all vars to be exposed in the task playbook
+# if you adjust this, also adjust html documentation
+_FORWARDED_VARS = [
+    'artifacts',
+    'taskotron_arch',
+    'taskotron_item_type',
+    'taskotron_item',
+    'taskotron_supported_arches',
+    'taskotron_supported_binary_arches',
+]
 
 
 class Executor(object):
@@ -72,18 +108,19 @@ class Executor(object):
         self.arg_data = arg_data
         self.task_vm = None
         self.run_remotely = False
+        self.ipaddr = self._get_client_ipaddr()
 
-    def _spawn_vm(self, uuid, playbook_data):
+    def _spawn_vm(self, uuid, playbook_vars):
         '''Spawn a virtual machine using testcloud.
 
         :param str uuid: unicode string uuid for the task being executed
-        :param playbook_data: instance of Playbook_Data with parsed vars from
-                              playbook
+        :param dict playbook_vars: a vars dict based on
+            :const:`_PLAYBOOK_VARS_TEMPLATE`
         :returns: str ip address of spawned vm
         '''
         log.info('Spawning disposable client')
 
-        env = image_utils.devise_environment(self.arg_data, playbook_data)
+        env = image_utils.devise_environment(self.arg_data, playbook_vars)
         self.task_vm = vm.TestCloudMachine(uuid)
 
         retries = config.get_config().spawn_vm_retries
@@ -167,84 +204,95 @@ class Executor(object):
                       e)
             raise exc.TaskotronPlaybookError(e)
 
-    def _run_playbook(self, test_playbook, ipaddr, playbook_data, root=True):
+    def _create_playbook_vars(self, test_playbook):
+        vars_ = copy.deepcopy(_PLAYBOOK_VARS_TEMPLATE)
+        cfg = config.get_config()
+
+        # load all provided taskotron_* vars first, so that they don't override
+        # out logic later on
+        with open(os.path.join(self.arg_data['taskdir'], test_playbook), 'r') \
+        as playbook_file:
+            playbook_yaml = yaml.safe_load(playbook_file.read())
+            # we only consider variables in the first play
+            playbook_vars = playbook_yaml[0].get('vars', {})
+        for var, val in playbook_vars.items():
+            if var.startswith('taskotron_'):
+                vars_[var] = val
+
+        # populate vars
+        vars_['taskotron_arch'] = self.arg_data['arch']
+        vars_['taskotron_item'] = self.arg_data['item']
+        vars_['taskotron_item_type'] = self.arg_data['type']
+        vars_['taskotron_supported_arches'] = cfg.supported_arches
+        vars_['taskotron_supported_binary_arches'] = [binarch for arch in
+            cfg.supported_arches for binarch in arch_utils.Arches.binary[arch]]
+        vars_['artifacts'] = os.path.join(self.arg_data['artifactsdir'],
+            test_playbook)
+        vars_['artifacts_root'] = self.arg_data['artifactsdir']
+        vars_['client_taskdir'] = cfg.client_taskdir
+        vars_['taskdir'] = self.arg_data['taskdir']
+        vars_['test_playbook'] = test_playbook
+        vars_['minion_repos'] = cfg.minion_repos
+        vars_['local'] = not self.run_remotely
+        vars_['heartbeat_file'] = os.path.join(vars_['artifacts_root'],
+            'taskotron', 'heartbeat.log')
+        if vars_['taskotron_generic_task']:
+            vars_['exec_tasks'] = 'tasks_generic.yml'
+        else:
+            vars_['exec_tasks'] = 'tasks_sti.yml'
+        if os.path.isfile(os.path.join(vars_['taskdir'], 'inventory')):
+            vars_['sti_inventory'] = os.path.join(vars_['client_taskdir'],
+                'inventory')
+        else:
+            vars_['sti_inventory'] = '/usr/share/ansible/inventory'
+
+        return vars_
+
+    def _run_playbook(self, test_playbook, ipaddr, playbook_vars):
         '''Run the ansible-playbook command to execute given playbook
         containing the task.
 
         :param str test_playbook: name of the playbook, relative to the task
             directory
         :param str ipaddr: IP address of the machine the task will be run on
-        :param playbook_data: instance of Playbook_Data with parsed vars from
-                              playbook
-        :param bool root: whether to run as ``root`` for local execution mode
-        :return: a tuple of ``(str, bool)``. The first item is stream output of
-            the ansible-playbook command (stdout and stderr merged together).
-            The second item marks whether this playbook is a Taskotron generic
-            task (``True``) or a plain STI task (``False``).
-        :rtype: tuple
+        :param dict playbook_vars: vars dict based on
+            :const:`_PLAYBOOK_VARS_TEMPLATE`
+        :return: stream output of the ansible-playbook command (stdout and
+            stderr merged together)
+        :rtype: str
         :raise TaskotronPlaybookError: when the playbook is not syntactically
             correct
         '''
-        # syntax check
-        self._check_playbook_syntax(
-            os.path.join(self.arg_data['taskdir'], test_playbook))
-
-        # compute variables
-        ansible_dir = os.path.join(config.get_config()._data_dir, 'ansible')
-        artifacts_subdir = os.path.join(self.arg_data['artifactsdir'],
-                                        test_playbook)
+        # save forwarded variables, so that task playbook can load them
+        fwdvars = {}
+        for fwdvar in _FORWARDED_VARS:
+            fwdvars[fwdvar] = playbook_vars[fwdvar]
+        file_utils.makedirs(os.path.join(playbook_vars['artifacts'],
+            'taskotron'))
+        varsfile = os.path.join(playbook_vars['artifacts'], 'taskotron',
+                'task_vars.json')
+        with open(varsfile, 'w') as vf:
+            vars_str = json.dumps(fwdvars, indent=2, sort_keys=True)
+            vf.write(vars_str)
+            log.debug('Saved task vars file %s with contents:\n%s',
+                      varsfile, vars_str)
 
-        if os.path.isfile(os.path.join(self.arg_data['taskdir'], 'inventory')):
-            sti_inventory = os.path.join(config.get_config().client_taskdir,
-                                        'inventory')
-        else:
-            sti_inventory = "/usr/share/ansible/inventory"
-
-        supported_arches = config.get_config().supported_arches
-        supported_binary_arches = [binarch for arch in supported_arches
-            for binarch in arch_utils.Arches.binary[arch]]
-
-        minion_repos = config.get_config().minion_repos
-
-        # set up variables to load into playbooks.
-        # separate them into the ones to forward, and the ones to use
-        # internally
-
-        # if you adjust forwarded variables, don't forget to adjust docs
-        # as well
-        ansible_vars = {
-            'artifacts': artifacts_subdir,
-            'taskotron_arch': self.arg_data['arch'],
-            'taskotron_item': self.arg_data['item'],
-            'taskotron_item_type': self.arg_data['type'],
-            'taskotron_supported_arches': supported_arches,
-            'taskotron_supported_binary_arches': supported_binary_arches,
-        }
-        varsfile = os.path.join(artifacts_subdir, 'taskotron',
-                                'ansible_vars.json')
-
-        ansible_vars_internal = {
-            'artifacts_root': self.arg_data['artifactsdir'],
-            'client_taskdir': config.get_config().client_taskdir,
-            'exec_tasks': playbook_data.exec_tasks,
-            'minion_repos': minion_repos,
-            'taskdir': self.arg_data['taskdir'],
-            'test_playbook': test_playbook,
-            'sti_inventory': sti_inventory,
-            'varsfile': os.path.basename(varsfile),
-        }
-        varsfile_internal = os.path.join(artifacts_subdir, 'taskotron',
-                                         'ansible_vars_internal.json')
-
-        if playbook_data.keepalive:
-            ansible_vars_internal['keepalive_minutes'] = playbook_data.keepalive
+        # save also all runner playbook variables, for debugging
+        allvarsfile = os.path.join(playbook_vars['artifacts'], 'taskotron',
+            'internal_vars.json')
+        with open(allvarsfile, 'w') as vf:
+            vars_str = json.dumps(playbook_vars, indent=2, sort_keys=True)
+            vf.write(vars_str)
+            log.debug('Saved internal ansible vars file %s with contents:\n%s',
+                      allvarsfile, vars_str)
 
+        ansible_dir = os.path.join(config.get_config()._data_dir, 'ansible')
         # figure out the ansible-playbook command
         cmd = [
             'ansible-playbook', 'runner.yml',
             '--inventory=%s,' % ipaddr,  # the ending comma is important
-            '--extra-vars=@%s' % varsfile,
-            '--extra-vars=@%s' % varsfile_internal,
+            '--extra-vars=@%s' % allvarsfile,
+            '--become',
         ]
 
         if self.run_remotely:
@@ -252,30 +300,10 @@ class Executor(object):
                 cmd.append('--private-key=%s' % self.arg_data['ssh_privkey'])
         else:
             cmd.append('--connection=local')
-            ansible_vars_internal['local'] = True
-            if root:
-                cmd.append('--become')
-                ansible_vars_internal['become_root'] = True
-            else:
-                ansible_vars_internal['become_root'] = False
 
         if self.arg_data['debug']:
             cmd.append('-vv')
 
-        # store the variables in json files, so that ansible can load them
-        file_utils.makedirs(os.path.join(artifacts_subdir, 'taskotron'))
-        with open(varsfile, 'w') as vf:
-            vars_str = json.dumps(ansible_vars, indent=2, sort_keys=True)
-            vf.write(vars_str)
-            log.debug('Saved ansible vars file %s with contents:\n%s',
-                      varsfile, vars_str)
-        with open(varsfile_internal, 'w') as vf:
-            vars_str = json.dumps(ansible_vars_internal, indent=2,
-                                  sort_keys=True)
-            vf.write(vars_str)
-            log.debug('Saved internal ansible vars file %s with contents:\n%s',
-                      varsfile_internal, vars_str)
-
         log.debug('Running ansible playbook %s', ' '.join(cmd))
         try:
             # during playbook execution, handle system signals asking us to
@@ -284,7 +312,7 @@ class Executor(object):
             signal.signal(signal.SIGTERM, self._interrupt_handler)
 
             output, _ = os_utils.popen_rt(cmd, cwd=ansible_dir)
-            return (output, playbook_data.generic)
+            return output
         except subprocess.CalledProcessError as e:
             log.error('ansible-playbook ended with %d return code',
                       e.returncode)
@@ -353,20 +381,27 @@ class Executor(object):
 
         failed = []
         for test_playbook in test_playbooks:
-            with open(os.path.join(self.arg_data['taskdir'], test_playbook), 'r') \
-            as playbook_file:
-                playbook_yaml = yaml.load(playbook_file.read())[0]
-                playbook_data = Playbook_Data(playbook_yaml)
-
-            ipaddr = self._get_client_ipaddr()
-            if ipaddr is None:
-                ipaddr = self._spawn_vm(self.arg_data['uuid'], playbook_data)
-
-            log.info('Running playbook %s on machine: %s', test_playbook, ipaddr)
-
             try:
-                _, generic = self._run_playbook(test_playbook, ipaddr, playbook_data)
-                if generic:
+                # syntax check
+                self._check_playbook_syntax(os.path.join(
+                    self.arg_data['taskdir'], test_playbook))
+
+                # compute variables
+                playbook_vars = self._create_playbook_vars(test_playbook)
+
+                # spawn VM if needed
+                ipaddr = self.ipaddr
+                if ipaddr is None:
+                    ipaddr = self._spawn_vm(self.arg_data['uuid'],
+                        playbook_vars)
+
+                # execute
+                log.info('Running playbook %s on machine: %s', test_playbook,
+                    ipaddr)
+                self._run_playbook(test_playbook, ipaddr, playbook_vars)
+
+                # report results
+                if playbook_vars['taskotron_generic_task']:
                     self._report_results(test_playbook)
             except exc.TaskotronInterruptError as e:
                 log.error('Caught system interrupt during execution of '
diff --git a/libtaskotron/image_utils.py b/libtaskotron/image_utils.py
index 5608ce0..56be9c1 100644
--- a/libtaskotron/image_utils.py
+++ b/libtaskotron/image_utils.py
@@ -17,47 +17,43 @@ except ImportError as e:
     raise exc.TaskotronImportError(e)
 
 
-def devise_environment(arg_data, playbook_data):
-    '''Takes an input item and type, and returns a required run-environment (i.e.
-    distro, arch, fedora release, and base-image flavor), based on item and type.
-
-    :param dict arg_data: parsed command-line arguments. item, type and arch
-                          are used in this method
-    :param bool match_host_arch: devise arch only when this param is True, otherwise
-                                 use default arch
-    :return: dict containing distro, release, flavor, arch. Each either set, or None
-    :raise TaskotronValueError: when environment can't be parsed from the formula
+def devise_environment(arg_data, playbook_vars):
+    '''Takes an input item and type, and returns a required run-environment,
+    or a default one, if the task doesn't require anything specific.
+
+    :param dict arg_data: parsed command-line arguments (item, type and arch
+        are used in this method)
+    :param dict playbook_vars: vars dict based on
+        :const:`executor._PLAYBOOK_VARS_TEMPLATE`
+    :return: dict containing ``distro``, ``release``, ``flavor`` and ``arch``.
+        Each either set, or ``None``.
     '''
 
     env = {'distro': None, 'release': None, 'flavor': None, 'arch': None}
 
-    item = arg_data.get('item', None)
-    item_type = arg_data.get('type', None)
+    item = arg_data['item']
+    item_type = arg_data['type']
+    arch = arg_data['arch']
 
-    if playbook_data.match_host_distro:
+    if playbook_vars['taskotron_match_host_distro']:
         if item_type == 'koji_build':
             # FIXME: find a way to make this not Fedora-specific
             # For `xchat-2.8.8-21.fc20` disttag is `fc20` for example
             try:
                 distro = rpm_utils.get_dist_tag(item)[:2]
-                env['distro'] = {'fc': 'fedora'}.get(distro, None)
+                env['distro'] = {'fc': 'fedora'}.get(distro)
             except exc.TaskotronValueError:
-                env['distro'] = None
+                log.debug('Failed to parse distro from koji build %s, using '
+                    'default', item)
 
         elif item_type == 'koji_tag':
             if re.match(r'^f[0-9]{2}-.*', item):
                 env['distro'] = 'fedora'
 
         if env['distro']:
-            log.debug("Environment/distro overriden with ENVVAR from %r:%r to %r",
-                      item_type, item, env['distro'])
-        else:
-            log.debug("Environment/distro can not be inferred from %r:%r. Using default.",
-                      item_type, item)
-    else:
-        log.debug('Variable taskotron_match_host_distro is set to False. Using default distro.')
-
-    if playbook_data.match_host_release:
+            log.debug('Forcing environment distro to %s', env['distro'])
+
+    if playbook_vars['taskotron_match_host_release']:
         if item_type == 'koji_build':
             # FIXME: find a way to make this not Fedora-specific
             # Last two characters in rpm's disttag are the Fedora release.
@@ -65,37 +61,26 @@ def devise_environment(arg_data, playbook_data):
             try:
                 env['release'] = rpm_utils.get_dist_tag(item)[-2:]
             except exc.TaskotronValueError:
-                env['release'] = None
+                log.debug('Failed to parse release from koji build %s, using '
+                    'default', item)
 
         elif item_type == 'koji_tag':
             if re.match(r'^f[0-9]{2}-.*', item):
                 env['release'] = item[1:3]
 
         if env['release']:
-            log.debug("Environment/release inferred from %r:%r to %r",
-                      item_type, item, env['release'])
-        else:
-            log.debug("Environment/release can not be inferred from %r:%r. Using default.",
-                      item_type, item)
-    else:
-        log.debug('Variable taskotron_match_host_release is set to False. Using default release.')
-
-    if not env['flavor']:
-        log.debug("Environment/flavor not specified. Using default")
-
-    if playbook_data.match_host_arch:
-        arch = arg_data.get('arch')
-        if not arch or arch == 'noarch':
-            log.warn("Environment/arch can not be inferred from %r. Using default.", arch)
-        else:
+            log.debug('Forcing environment release to %s', env['release'])
+
+    if playbook_vars['taskotron_match_host_arch']:
+        if arch != 'noarch':
             env['arch'] = arch
-            log.debug("Environment/arch inferred from %r to %r", arch, env['arch'])
-    else:
-        log.debug('Variable taskotron_match_host_arch is set to False. Using default arch.')
+            log.debug('Forcing environment arch to %s', env['arch'])
 
     env['distro'] = env['distro'] or config.get_config().default_disposable_distro
     env['release'] = env['release'] or config.get_config().default_disposable_release
     env['flavor'] = env['flavor'] or config.get_config().default_disposable_flavor
     env['arch'] = env['arch'] or config.get_config().default_disposable_arch
 
+    log.debug('Devised environment: %s', env)
+
     return env

